﻿using Microsoft.AspNetCore.Cryptography.KeyDerivation;
using Microsoft.AspNetCore.Identity;
using System.Security.Cryptography;

namespace Blazor.Models;

public class AdministratorsModel : PasswordHasher<string>
{
    public int Id { get; private set; }
    public string Username { get; private set; }
    public string HashedPassword { get; set; }

    private byte[] salt = RandomNumberGenerator.GetBytes(128 / 8); // for password hash

    AdministratorsModel(int id, string username, string password)
    {
        this.Id = id;
        this.Username = username;
        //hash password
        this.HashedPassword = Convert.ToBase64String(KeyDerivation.Pbkdf2(
            password: password!,
            salt: salt,
            prf: KeyDerivationPrf.HMACSHA256,
            iterationCount: 100000,
            numBytesRequested: 256 / 8)
        );
    }
}
